<?php

namespace App\Nova\Resources\Branch;

use App\Models\Branch\Branch as BranchModel;
use App\Nova\Resources\Branch\Concerns\BranchNovaRepo;
use App\Repos\System\Settings\Location\RegionRepo;
use Illuminate\Http\Request;
use Laravel\Nova\Fields\ID;
use Laravel\Nova\Fields\Select;
use Laravel\Nova\Fields\Text;
use Laravel\Nova\Fields\Textarea;
use Laravel\Nova\Http\Requests\NovaRequest;
use Laravel\Nova\Resource;
use Trin4ik\NovaSwitcher\NovaSwitcher;

class Branch extends Resource
{
    /**
     * The model the resource corresponds to.
     *
     * @var class-string<BranchModel>
     */
    public static $model = BranchModel::class;

    /**
     * The single value that should be used to represent the resource when being displayed.
     *
     * @var string
     */
    public static $title = 'name';

    /**
     * The columns that should be searched.
     *
     * @var array
     */
    public static $search = [
        'name', 'unique_code',
    ];

    /**
     * Get the displayable label of the resource.
     */
    public static function label(): string
    {
        return __('Branches');
    }

    /**
     * Get the displayable singular label of the resource.
     */
    public static function singularLabel(): string
    {
        return __('Branch');
    }

    /**
     * Get the fields displayed by the resource.
     */
    public function fields(NovaRequest $request): array
    {
        return [
            ID::make()->sortable(),

            Text::make(__('Name'), 'name')
                ->rules('required', 'string', 'max:255')
                ->translatable(),

            Select::make(__('Region'), 'region')
                ->displayUsingLabels()
                ->searchable()
                ->options(RegionRepo::values())
                ->default(RegionRepo::default())
                ->rules('required')
                ->sortable(),

            Select::make(__('Province'), 'province_id')
                ->displayUsingLabels()
                ->searchable()
                ->dependsOn('region', BranchNovaRepo::dependsOnRegion()),

            Text::make(__('Unique code'), 'unique_code')
                ->rules('required', 'string', 'max:255'),

            Text::make(__('Billing username'), 'billing_username')
                ->rules('nullable', 'string', 'max:255'),

            Text::make(__('Billing password'), 'billing_password')
                ->rules('nullable', 'string', 'max:255'),

            Textarea::make(__('Address'), 'address'),

            NovaSwitcher::make(__('Active'), 'active')
                ->default(true),
        ];
    }

    /**
     * Get the cards available for the request.
     *
     * @return array
     */
    public function cards(NovaRequest $request)
    {
        return [];
    }

    /**
     * Get the filters available for the resource.
     *
     * @return array
     */
    public function filters(NovaRequest $request)
    {
        return [];
    }

    /**
     * Get the lenses available for the resource.
     *
     * @return array
     */
    public function lenses(NovaRequest $request)
    {
        return [];
    }

    /**
     * Get the actions available for the resource.
     *
     * @return array
     */
    public function actions(NovaRequest $request)
    {
        return [];
    }
}
